;
; Adlib-DigiSnap Reader - copyright 2000 by Yehar
;

locals
.486p

include pmode.inc
include file.inc

public _main
assume cs : pgroup, ds : pgroup, es : pgroup, fs : pgroup, gs : zero32
pgroup group code32, data32, bss32

;
; Constants
;

BufLen          = 49720
Buffers         = 60*9

SCOPESCALE      = 400
SCOPEPACK       = 1
TRIGGERMAX      = 49720/20
SCOPECOLOR      = 0fh
SCOPECOLOR2     = 0ah
SCOPECOLOR3     = 02h

BASEPORT        = 278h
PORTIRQ         = 05h

;
; Memory
;

zero32 segment at 0

org 0a0000h
videomem db 320*200 dup (?)
org 0b8000h
txtvideomem db 160*25 dup (?)

ends

;
; Data. Variables, saved into exe
;

data32 segment para public use32

WritePos        dd      0
WordsInWorkBuf  dd      0
IsBufFilled     dd      0
FilledBufNum    dd      0
WorkBufNum      dd      0
Wrapped         dd      0
TriggerPos      dd      0

OutFileName     db      'OUTPUT.RAW', 0
PreviousHi      db      0

ScopeY          dd      320 dup (100*320)

ends

;
; Data. Variables, not saved into exe
;

bss32 segment para public use32 uninit

Handle          dw      ?
OldIntPmode     dd      ?
OldIntRealMode  dd      ?
irq_stub_buf    db      21 dup (?)
Buf             dd      ?

ends

;
; Code
;

code32 segment para public use32

wfvr proc
                push    dx
                push    ax
                mov dx,3dah             ;Odotetaan v-retracea
@@novrx:        in al,dx                ;
                test al,00001000b       ;
                jz @@novrx              ;
@@novrx2:        in al,dx               ;
                test al,00001000b       ;
                jnz @@novrx2            ;
                pop     ax
                pop     dx
                ret
wfvr endp

processdata proc
                ;Process Buf

;                mov     es, _selzero
;                mov     EAX, offset zero32:videomem
;                mov     ECX, FilledBufNum
;                mov     ES:EAX[0], ECX

enoughsamples2:

                ret     
processdata endp

InitInt proc near
                cli
                mov     BL, PORTIRQ
                call    _getirqvect
                mov     OldIntPMode, EDX

                mov     BL, PORTIRQ
                mov     EDX, offset pgroup:MyIntRoutine
                call    _setirqvect

                mov     BL, PORTIRQ
                mov     EDX, offset pgroup:MyIntRoutine
                mov     EDI, offset pgroup:irq_stub_buf
                call    _rmpmirqset
                mov     OldIntRealMode, EAX

                mov     DX, BASEPORT+2
                mov     AL, 00110100b ;00110100b
                out     DX, AL

                mov     BL, PORTIRQ
                mov     AL, 0
                call    _setirqmask

                sti

@@fuck:         ret
InitInt endp

DeInitInt proc near
                cli
                mov     DX, BASEPORT+2
                mov     AL, 00000000b
                out     DX, AL

                mov     BL, PORTIRQ
                mov     AL, 1
                call    _setirqmask

                mov     BL, PORTIRQ
                mov     EAX, OldIntRealMode
                call    _rmpmirqfree

                mov     BL, PORTIRQ
                mov     EDX, OldIntPMode
                call    _setirqvect

                sti

                ret
DeInitInt endp

MyIntRoutine  proc far
                pushad
                push    DS
                mov     DS, CS:_seldata

                mov     DX, BASEPORT+4
                in      AL, DX
                mov     CH, AL
                mov     DX, BASEPORT+3
                in      AL, DX
                mov     CL, AL
                mov     AH, CH

                mov     EDI, WritePos
                mov     EBX, Buf
;                mov     AX, CX
;                and     CX, 0000111100001111b
;                and     AX, 1111000011110000b
;                shl     CX, 4
;                shr     AX, 4
;                or      AX, CX
;                mov     CX, AX
;                and     AX, 1100110011001100b
;                and     CX, 0011001100110011b
;                shr     AX, 2
;                shl     CX, 2
;                or      AX, CX
;                mov     CX, AX
;                and     AX, 1010101010101010b
;                and     CX, 0101010101010101b
;                shr     AX, 1
;                shl     CX, 1
;                or      CX, AX
;                mov     AX, CX

                ; CX = AX, containing:
                ;
                ; FEDCBA9876543210
                ; [X][MANTISSA]---

                shr     CX, 0dh
                jz      @@illegalexp
                dec     CX

                shr     AX, 3
                and     AX, 0000001111111111b
                sub     AX, 0000001000000000b

;                setns   DL
;                jns     @@thishi
;                @@thisnothi:
;                cmp     PreviousHi, 1
;                je      @@settrigger
;                @@thishi:
;                @@donetrigger:
;                mov     PreviousHi, DL

                sal     AX, CL

                mov     DS:[EBX+EDI], AX
                jmp     @@legalexp
                @@illegalexp:
                mov     word ptr DS:[EBX+EDI], 0
                @@legalexp:

                inc     WordsInWorkBuf
                add     WritePos, 2
                cmp     WordsInWorkBuf, BufLen
                jnae    @@StayBuf
                mov     EAX, WorkBufNum
                mov     FilledBufNum, EAX
                inc     EAX
                cmp     EAX, Buffers
                jnae    @@NoWrap
                xor     EAX, EAX
                mov     WritePos, 0
                mov     Wrapped, 1
                @@NoWrap:
                mov     WorkBufNum, EAX
                mov     IsBufFilled, 1
                mov     WordsInWorkBuf, 0
                @@StayBuf:

                mov     AL, 00100000b ;EOI
                out     20h, AL       ;
                pop     DS
                popad
                sti
                iretd

;                @@settrigger:
;                mov TriggerPos, EDI
;                jmp @@donetrigger
MyIntRoutine  endp

_main           proc
                sti
                cld

                movzx eax,_filebuflen           ; allocate low memory for file buffer
                call _getlomem                  ;  it will only be used if high memory
                jc @@error                      ;  is needed to load in the full input
                mov _filebufloc,eax             ;  file

                mov     v86r_ax, 13h
                mov     AL, 10h
                call    _rmint

                mov     EAX, BufLen*Buffers*2
                call    _gethimem
                mov     Buf, EAX
                jc      @@error

                call InitInt

mainloop:
                test    IsBufFilled, 1
                jz      stillgottowait
                mov     IsBufFilled, 0

                imul    EBX, FilledBufNum, BufLen*2
                add     EBX, Buf
                mov     EBP, BufLen*2
                call    processdata

                stillgottowait:

                mov     v86r_ah, 1  ;anykey?
                mov     AL, 16h
                call    _rmint
                jnz     offmainloop

                call    wfvr
                call    scope

                jmp     mainloop
                offmainloop:
                call    DeInitInt

                test    IsBufFilled, 1
                jz      @@Partial
                imul    EBX, FilledBufNum, BufLen*2
                add     EBX, Buf
                mov     EBP, BufLen*2
                call    processdata
                @@Partial:
                imul    EBX, WorkBufNum, BufLen*2
                test    EBX, EBX
                add     EBX, Buf
                mov     EBP, WordsInWorkBuf
                shl     EBP, 1
                jz      @@Nopartial
                call    processdata
                @@Nopartial:

;                jmp @@error

           ;Create file

                mov     EDX, offset pgroup:OutFileName
                call    _createfile
                jc      @@Error
                mov     BX, v86r_bx
                mov     Handle, BX

           ;Write

                mov     BX, Handle
                mov     v86r_bx, BX
                test    Wrapped, 1
                jz      @@startpart
                ;;wrap:
                mov     ECX, Buffers-1
                sub     ECX, WorkBufNum
                jz      @@startpart
                ;;endpart:
                imul    ECX, BufLen*2
                mov     EDX, WorkBufNum
                inc     EDX
                imul    EDX, BufLen*2
                add     EDX, Buf
                call    _writefile
                @@startpart:
                imul    ECX, WorkBufNum, BufLen
                add     ECX, WordsInWorkBuf
                test    ECX, ECX
                jz      @@nothing
                shl     ECX, 1
                mov     EDX, Buf
                call    _writefile
                @@nothing:

           ;Close file

                mov     BX, Handle
                mov     v86r_bx, BX
                call    _closefile

                mov     v86r_ax, 3h
                mov     AL, 10h
                call    _rmint

                mov     _exitcode, 0
                jmp     _exit

                @@Error:
                mov     v86r_ax, 3h
                mov     AL, 10h
                call    _rmint

                mov     _exitcode, 1
                jmp     _exit

_main           endp

scope proc

                mov EBX, Buf
                mov ESI, WritePos
                mov es, _selzero

;                mov EBP, TriggerPos
;                neg EBP
;                add EBP, ESI
;                cmp EBP, TRIGGERMAX
;                ja @@notrigger
;                mov ESI, TriggerPos
;                @@notrigger:


                sub ESI, 2
                js @@jooh

                movsx EBP, word ptr DS:[EBX+ESI]
                imul EBP, -SCOPESCALE
                sar EBP, 16
                add EBP, 100
                jns @@noclip11
                xor EBP, EBP
                @@noclip11:
                cmp EBP, 199
                jna @@noclip12
                mov EBP, 199
                @@noclip12:
                imul EBP, 320
                mov EDX, ScopeY[319*4]

                mov ECX, 320
                @@scopeloop:

                movsx EAX, word ptr DS:[EBX+ESI]
                imul EAX, -SCOPESCALE
                sar EAX, 16
                add EAX, 100
                jns @@noclip21
                xor EAX, EAX
                @@noclip21:
                cmp EAX, 199
                jna @@noclip22
                mov EAX, 199
                @@noclip22:
                imul EAX, 320

                mov EDI, ScopeY[ECX*4-4]
                cmp EDX, EDI
                mov ES:videomem[EDX+ECX-1], 0
                je @@outlineloop2
                ja @@mustdec2
                @@mustinc2:
                add EDX, 320
                cmp EDX, EDI
                je @@outlineloop2
                mov ES:videomem[EDX+ECX-1], 0
                jmp @@mustinc2
                @@mustdec2:
                sub EDX, 320
                cmp EDX, EDI
                je @@outlineloop2
                mov ES:videomem[EDX+ECX-1], 0
                jmp @@mustdec2
                @@outlineloop2:
                mov ES:videomem[EDX+ECX-1], 0

                mov ScopeY[ECX*4-4], EAX
                cmp EBP, EAX
                mov ES:videomem[EBP+ECX-1], SCOPECOLOR3
                je @@outlineloop
                ja @@mustdec
                @@mustinc:
                add EBP, 320
                cmp EBP, EAX
                je @@outlineloop
                mov ES:videomem[EBP+ECX-1], SCOPECOLOR
                jmp @@mustinc
                @@mustdec:
                sub EBP, 320
                cmp EBP, EAX
                je @@outlineloop
                mov ES:videomem[EBP+ECX-1], SCOPECOLOR
                jmp @@mustdec
                @@outlineloop:
                mov ES:videomem[EBP+ECX-1], SCOPECOLOR2

                sub ESI, 2*SCOPEPACK
                js @@jooh

                dec ECX
                jnz @@scopeloop
                @@jooh:
                ret
scope endp

ends
end
